Index: issm/branches/trunk-jpl-damage/externalpackages/vim/addons/vim/syntax/c.vim
===================================================================
--- issm/branches/trunk-jpl-damage/externalpackages/vim/addons/vim/syntax/c.vim	(revision 12877)
+++ issm/branches/trunk-jpl-damage/externalpackages/vim/addons/vim/syntax/c.vim	(revision 12878)
@@ -404,9 +404,9 @@
 """""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""
 "ISSM containers:
-syn keyword	cType		Constraints DataSet Elements Inputs Loads Materials Nodes Parameters Results Vertices
+syn keyword	cType		Constraints DataSet Elements Inputs Loads Materials Nodes Parameters Results Vertices Options
 "Petsc
-syn keyword	cType		Vec Mat
+syn keyword	cType		Vec Mat SeqVec SeqMat
 "other ISSM's syntax
-syn keyword	cType		mxArray ErrorException
+syn keyword	cType		mxArray ErrorException QuadtreeBox IssmDouble IssmPDouble
 
 "ISSM's objects begin
@@ -545,5 +545,5 @@
 syn keyword cType Mesh
 syn keyword cType Geometry
-syn keyword cType QuadTree
+syn keyword cType BamgQuadtree
 syn keyword cType SetOfE4
 syn keyword cType Variogram
@@ -551,4 +551,5 @@
 syn keyword cType ExponentialVariogram
 syn keyword cType SphericalVariogram
+syn keyword cType PowerVariogram
 syn keyword cType Quadtree
 syn keyword cType Observation
@@ -649,4 +650,5 @@
 syn keyword cConstant MaterialsRhoIceEnum
 syn keyword cConstant MaterialsRhoWaterEnum
+syn keyword cConstant MaterialsRhoFreshwaterEnum
 syn keyword cConstant MaterialsMuWaterEnum
 syn keyword cConstant MaterialsThermalExchangeVelocityEnum
@@ -694,8 +696,15 @@
 syn keyword cConstant SettingsResultsAsPatchesEnum
 syn keyword cConstant SettingsWaitonlockEnum
-syn keyword cConstant DebugPetscProfilingEnum
-syn keyword cConstant PetscProfilingCurrentMemEnum
-syn keyword cConstant PetscProfilingCurrentFlopsEnum
-syn keyword cConstant PetscProfilingSolutionTimeEnum
+syn keyword cConstant SurfaceforcingsDelta18oEnum
+syn keyword cConstant SurfaceforcingsDelta18oTemperaturesPresentdayEnum
+syn keyword cConstant SurfaceforcingsDelta18oTemperaturesLgmEnum
+syn keyword cConstant SurfaceforcingsDelta18oSurfaceEnum
+syn keyword cConstant SurfaceforcingsIsdelta18oEnum
+syn keyword cConstant SurfaceforcingsPrecipitationsPresentdayEnum
+syn keyword cConstant DebugProfilingEnum
+syn keyword cConstant ProfilingCurrentMemEnum
+syn keyword cConstant ProfilingCurrentFlopsEnum
+syn keyword cConstant ProfilingSolutionTimeEnum
+syn keyword cConstant MaxIterationConvergenceFlagEnum
 syn keyword cConstant SteadystateMaxiterEnum
 syn keyword cConstant SteadystateNumRequestedOutputsEnum
@@ -796,4 +805,5 @@
 syn keyword cConstant IntParamEnum
 syn keyword cConstant IntVecParamEnum
+syn keyword cConstant TransientParamEnum
 syn keyword cConstant MacAyeal2dIceFrontEnum
 syn keyword cConstant MacAyeal3dIceFrontEnum
@@ -915,4 +925,5 @@
 syn keyword cConstant StressTensorzzEnum
 syn keyword cConstant IceVolumeEnum
+syn keyword cConstant TotalSmbEnum
 syn keyword cConstant P0Enum
 syn keyword cConstant P1Enum
Index: issm/branches/trunk-jpl-damage/m4/issm_options.m4
===================================================================
--- issm/branches/trunk-jpl-damage/m4/issm_options.m4	(revision 12877)
+++ issm/branches/trunk-jpl-damage/m4/issm_options.m4	(revision 12878)
@@ -12,5 +12,14 @@
 		AC_DEFINE([_ISSM_DEBUG_],[1],[Macro to enable debugging in ISSM])
 	fi
-	dnl }}}
+
+	dnl }}}
+    dnl shared build {{{
+    AC_ARG_ENABLE([shared],                                                dnl feature
+        AS_HELP_STRING([--enable-shared], [produce libISSM.so.0]),         dnl help string
+        [enable_shared=$enableval],                                        dnl action if given
+        [enable_shared=no])                                                dnl action if not given
+    AM_CONDITIONAL([SHARED], [test $enable_shared = yes])
+    dnl }}}
+
 	dnl Modules build {{{
 	AC_ARG_WITH([modules],
@@ -60,4 +69,9 @@
 			export CFLAGS=" -D_INTEL_LINUX_"
 			export CXXFLAGS=" -D_INTEL_LINUX_"
+		elif test $VENDOR = intel-discover; then
+			export CC=icc
+			export CXX=icpc
+			export CXXFLAGS=" -O3 -D_INTEL_LINUX_ "
+			export CFLAGS=" -O3 -D_INTEL_LINUX_ "
 		elif test $VENDOR = intel-pleiades; then
 			export CC=icc
@@ -65,10 +79,4 @@
 			export CXXFLAGS=" -O3 -xS -D_INTEL_LINUX_ "
 			export CFLAGS=" -O3 -xS -D_INTEL_LINUX_ "
-		elif test $VENDOR = arm-linux; then
-			export CC=$ANDROID_DIR/arm-linux-android-4.0/bin/arm-linux-androideabi-gcc
-			export GCC=$ANDROID_DIR/arm-linux-android-4.0/bin/arm-linux-androideabi-gcc
-			export CXX=$ANDROID_DIR/arm-linux-android-4.0/bin/arm-linux-androideabi-g++
-			export AR=$ANDROID_DIR/arm-linux-android-4.0/bin/arm-linux-androideabi-ar
-			export RANLIB=$ANDROID_DIR/arm-linux-android-4.0/bin/arm-linux-androideabi-ranlib
         else
 		AC_MSG_ERROR([unknow compiler vendor!])
@@ -308,24 +316,4 @@
 	AC_MSG_RESULT($HAVE_BOOST)
 	dnl }}}
-	dnl python-version{{{
-	AC_ARG_WITH([python-version],
-	  AS_HELP_STRING([--with-python-version = PYTHONVERSION],[python version.]),
-	  [PYTHONVERSION=$withval],[PYTHONVERSION=""])
-	AC_MSG_CHECKING(for python version)
-
-	HAVE_PYTHON3="no"
-
-	dnl recover major: 
-	PYTHON_MAJOR=${PYTHONVERSION%.*}
-
-	if test x$PYTHON_MAJOR = x3; then
-		dnl are we running python 3?
-		HAVE_PYTHON3="yes"
-	fi
-	AC_DEFINE_UNQUOTED([_PYTHON_MAJOR_],$PYTHON_MAJOR,[python version major])
-
-	AM_CONDITIONAL([PYTHON3], [test x$HAVE_PYTHON3 = xyes])
-	AC_MSG_RESULT($PYTHON_MAJOR)
-	dnl }}}
 	dnl python{{{
 	AC_ARG_WITH([python-dir],
@@ -336,9 +324,37 @@
 	if test -d "$PYTHON_ROOT"; then
 		dnl defaults
+		HAVE_PYTHON3="no"
 		HAVE_PYTHON=yes
+		
+		AC_ARG_WITH([python-version],
+		  AS_HELP_STRING([--with-python-version = PYTHONVERSION],[python version.]),
+		  [PYTHONVERSION=$withval],[PYTHONVERSION=""])
+		AC_MSG_CHECKING(for python version)
+
+		dnl recover major: 
+		PYTHON_MAJOR=${PYTHONVERSION%.*}
+
+		if test x$PYTHON_MAJOR = x3; then
+			dnl are we running python 3?
+			HAVE_PYTHON3="yes"
+		fi
+		AC_DEFINE_UNQUOTED([_PYTHON_MAJOR_],$PYTHON_MAJOR,[python version major])
+		AC_MSG_RESULT($PYTHON_MAJOR)
+
 		PYTHONINCL=-I$PYTHON_ROOT/include
 		PYTHONLIB="-L$PYTHON_ROOT/lib -lpython$PYTHONVERSION"
 		PYTHONEXT=.so
-		PYTHONLINK="-dynamiclib"
+
+		case "${host_os}" in
+			*cygwin*)
+			PYTHONLINK="-shared"
+			;;
+			*linux*)
+			PYTHONLINK="-shared"
+			;;
+			*darwin*)
+			PYTHONLINK="-dynamiclib"
+			;;
+		esac
 
 		AC_DEFINE([_HAVE_PYTHON_],[1],[with Python in ISSM src])
@@ -352,5 +368,7 @@
 	fi
 	AM_CONDITIONAL([PYTHON], [test x$HAVE_PYTHON = xyes])
+	AM_CONDITIONAL([PYTHON3], [test x$HAVE_PYTHON3 = xyes])
 	AC_MSG_RESULT($HAVE_PYTHON)
+
 	dnl }}}
 	dnl python-numpy{{{
@@ -429,5 +447,5 @@
 			dnl defaults
 			HAVE_ADOLC=yes
-			ADOLCINCL="-I$ADOLC_ROOT/include/adolc -I$ADOLC_ROOT/include"
+			ADOLCINCL="-I$ADOLC_ROOT/include"
 			ADOLCLIB="-L$ADOLC_ROOT/lib64 -ladolc"
 
@@ -483,5 +501,5 @@
 		HAVE_GSL=yes
 		GSLINCL="-I$GSL_ROOT/include"
-		GSLLIB="-L$GSL_ROOT/lib/ -lgsl -lgslcblas -lm"
+		GSLLIB="-dy -L$GSL_ROOT/lib/ -lgsl -lgslcblas -lm"
 
 		AC_DEFINE([_HAVE_GSL_],[1],[with gsl in ISSM src])
@@ -523,7 +541,7 @@
 	  [METIS_ROOT=$withval],[METIS_ROOT=""])
 
+   AC_MSG_CHECKING(for metis headers and libraries in $METIS_ROOT)
+
 	if test -d "$METIS_ROOT"; then
-
-		AC_MSG_CHECKING(for metis headers and libraries in $METIS_ROOT)
 
 		dnl first figure out version of metis: does the VERSION file exist?
@@ -579,4 +597,5 @@
 	fi
 	AM_CONDITIONAL([METIS], [test x$HAVE_METIS = xyes])
+	AC_MSG_RESULT($HAVE_METIS)
 	dnl }}}
 	dnl mpi{{{
@@ -746,5 +765,9 @@
 		dnl defaults
 		HAVE_SCALAPACK=yes
-		SCALAPACKLIB=-L"$SCALAPACK_ROOT/ -lscalapack"
+		if test x$VENDOR = xintel-discover; then
+		 SCALAPACKLIB=-L"$SCALAPACK_ROOT/ -lmkl_scalapack_lp64"
+		else
+		 SCALAPACKLIB=-L"$SCALAPACK_ROOT/ -lscalapack"
+		fi
 
 		AC_DEFINE([_HAVE_SCALAPACK_],[1],[with Scalapack in ISSM src])
@@ -766,5 +789,8 @@
 		HAVE_BLASLAPACK=yes
 		BLASLAPACKINCL=""
-		
+	
+		if test x$VENDOR = xintel-discover; then
+		 BLASLAPACKLIB=-L"$BLASLAPACK_ROOT -lmkl_lapack -lmkl -lguide -lpthread"
+		else
 		dnl: branch on whether we are running on windows or linux.
 		case "${host_os}" in
@@ -779,4 +805,5 @@
 			;;
 		esac
+		fi
 
 		AC_DEFINE([_HAVE_BLASLAPACK_],[1],[with blas lapack in ISSM src])
@@ -853,4 +880,5 @@
 		MUMPSLIB=-L"$MUMPS_ROOT/lib -ldmumps -lcmumps  -lpord "
 		else
+		dnl MUMPSLIB=-L"$MUMPS_ROOT/lib -ldmumps -lcmumps  -lmumps_common -lpord -lparmetis -lzmumps"
 		MUMPSLIB=-L"$MUMPS_ROOT/lib -ldmumps -lcmumps  -lmumps_common -lpord -lparmetis"
 		fi
@@ -875,5 +903,9 @@
 		HAVE_BLACS=yes
 		BLACSINCL=""
-		BLACSLIB=-L"$BLACS_ROOT/ -lblacs"
+		if test x$VENDOR = xintel-discover; then
+		 BLACSLIB=-L"$BLACS_ROOT/ -lmkl_blacs_intelmpi_lp64"
+		else
+		 BLACSLIB=-L"$BLACS_ROOT/ -lblacs"
+		fi
         
 		AC_DEFINE([_HAVE_BLACS_],[1],[with Blacs in ISSM src])
@@ -896,5 +928,5 @@
 		HAVE_HYPRE=yes
 		HYPREINCL=""
-		HYPRELIB=-L"$HYPRE_ROOT/ -lHYPRE"
+		HYPRELIB=-L"$HYPRE_ROOT/lib -lHYPRE"
         
 		AC_DEFINE([_HAVE_HYPRE_],[1],[with Blacs in ISSM src])
@@ -906,4 +938,109 @@
 	AC_MSG_RESULT($HAVE_HYPRE)
 	dnl }}}
+	dnl prometheus{{{
+		AC_ARG_WITH([prometheus-dir],
+					AS_HELP_STRING([--with-prometheus-dir=DIR],[prometheus root directory]),
+					[PROMETHEUS_ROOT=$withval],[PROMETHEUS_ROOT=""])
+
+		  AC_MSG_CHECKING(for prometheus headers and libraries in $PROMETHEUS_ROOT)
+		  if test -d "$PROMETHEUS_ROOT"; then
+
+			dnl defaults
+			  HAVE_PROMETHEUS=yes
+			  PROMETHEUSINCL=-I"$PROMETHEUS_ROOT/include"
+			  PROMETHEUSLIB=-L"$PROMETHEUS_ROOT/lib -lpromfei -lprometheus -lparmetis"
+
+			  AC_DEFINE([_HAVE_PROMETHEUS_],[1],[with Prometheus in ISSM src])
+			  AC_SUBST([PROMETHEUSINCL])
+			  AC_SUBST([PROMETHEUSLIB])
+		  else
+				HAVE_PROMETHEUS=no
+			fi
+			AC_MSG_RESULT($HAVE_PROMETHEUS)
+		dnl }}}
+dnl spai{{{
+	AC_ARG_WITH([spai-dir],
+				AS_HELP_STRING([--with-spai-dir=DIR],[spai root directory]),
+				[SPAI_ROOT=$withval],[SPAI_ROOT=""])
+
+	  AC_MSG_CHECKING(for spai headers and libraries in $SPAI_ROOT)
+	  if test -d "$SPAI_ROOT"; then
+
+		dnl defaults
+		  HAVE_SPAI=yes
+		  SPAIINCL=-I"$SPAI_ROOT/include"
+		  SPAILIB=-L"$SPAI_ROOT/lib -lspai"
+
+		  AC_DEFINE([_HAVE_SPAI_],[1],[with Spai in ISSM src])
+		  AC_SUBST([SPAIINCL])
+		  AC_SUBST([SPAILIB])
+	  else
+		HAVE_SPAI=no
+		  fi
+		  AC_MSG_RESULT($HAVE_SPAI)
+		  dnl }}}
+dnl superlu{{{ 
+	AC_ARG_WITH([superlu-dir],
+				AS_HELP_STRING([--with-superlu-dir=DIR],[superlu root directory]),
+				[SUPERLU_ROOT=$withval],[SUPERLU_ROOT=""])
+
+	  AC_MSG_CHECKING(for superlu headers and libraries in $SUPERLU_ROOT)
+	  if test -d "$SUPERLU_ROOT"; then
+
+		dnl defaults
+		  HAVE_SUPERLU=yes
+		  SUPERLUINCL=-I"$SUPERLU_ROOT/include"
+		  SUPERLULIB=-L"$SUPERLU_ROOT/lib -lsuperlu_4.3"
+
+		  AC_DEFINE([_HAVE_SUPERLU_],[1],[with Superlu in ISSM src])
+		  AC_SUBST([SUPERLUINCL])
+		  AC_SUBST([SUPERLULIB])
+	  else
+		HAVE_SUPERLU=no
+		  fi
+		  AC_MSG_RESULT($HAVE_SUPERLU)
+		  dnl }}}
+dnl spooles{{{ 
+	AC_ARG_WITH([spooles-dir],
+				AS_HELP_STRING([--with-spooles-dir=DIR],[spooles root directory]),
+				[SPOOLES_ROOT=$withval],[SPOOLES_ROOT=""])
+
+	  AC_MSG_CHECKING(for spooles headers and libraries in $SPOOLES_ROOT)
+	  if test -d "$SPOOLES_ROOT"; then
+
+		dnl defaults
+		  HAVE_SPOOLES=yes
+		  SPOOLESINCL=-I"$SPOOLES_ROOT/include"
+		  SPOOLESLIB=-L"$SPOOLES_ROOT/lib -lspooles"
+
+		  AC_DEFINE([_HAVE_SPOOLES_],[1],[with Spooles in ISSM src])
+		  AC_SUBST([SPOOLESINCL])
+		  AC_SUBST([SPOOLESLIB])
+	  else
+		HAVE_SPOOLES=no
+		  fi
+		  AC_MSG_RESULT($HAVE_SPOOLES)
+		  dnl }}}
+dnl pastix{{{ 
+	AC_ARG_WITH([pastix-dir],
+				AS_HELP_STRING([--with-pastix-dir=DIR],[pastix root directory]),
+				[PASTIX_ROOT=$withval],[PASTIX_ROOT=""])
+
+	  AC_MSG_CHECKING(for pastix headers and libraries in $PASTIX_ROOT)
+	  if test -d "$PASTIX_ROOT"; then
+
+		dnl defaults
+		  HAVE_PASTIX=yes
+		  PASTIXINCL=-I"$PASTIX_ROOT/include"
+		  PASTIXLIB=-L"$PASTIX_ROOT/lib -lpastix_XXbit_mpi_smp_nobubble_int32_simple_real_scotch_i686_pc_linux -lptscotch -lptscotcherr -lpastix"
+
+		  AC_DEFINE([_HAVE_PASTIX_],[1],[with Pastix in ISSM src])
+		  AC_SUBST([PASTIXINCL])
+		  AC_SUBST([PASTIXLIB])
+	  else
+		HAVE_PASTIX=no
+		  fi
+		  AC_MSG_RESULT($HAVE_PASTIX)
+		  dnl }}}
 	dnl ml{{{
 	AC_ARG_WITH([ml-dir],
@@ -944,25 +1081,34 @@
 	dnl }}}
 	dnl fortran{{{
-	dnl fortran library  option
-	AC_MSG_CHECKING(for fortran library)
-	AC_ARG_WITH([fortran-lib],
-	  AS_HELP_STRING([--with-fortran-lib = options],[fortran options, for ex: "/usr/lib/gfortran.a]),
-		[FORTRAN_LIB=$withval],[FORTRAN_LIB=""])
-
-	dnl check that --with-fortran-lib may have been provided
-	HAVE_FORTRAN=no
-	if test -n "$FORTRAN_LIB" ; then
-        if test x$FORTRAN_LIB = xno; then
-            HAVE_FORTRAN=NO
-        else
-            HAVE_FORTRAN=yes
-            FORTRANLIB="$FORTRAN_LIB"
-
-            AC_DEFINE([_HAVE_FORTRAN_],[1],[with FORTRAN in ISSM src])
-            AC_SUBST([FORTRANLIB])
-        fi
-	fi
-	AM_CONDITIONAL([FORTRAN], [test x$HAVE_FORTRAN = xyes])
-	AC_MSG_RESULT(done)
+	AC_ARG_WITH([fortran],
+		AS_HELP_STRING([--with-fortran = YES], [do we compile fortran code (default is yes)]),
+		[FORTRAN=$withval],[FORTRAN=yes]) 
+	AC_MSG_CHECKING(for fortran compilation)
+	if test "x$FORTRAN" = "xyes"; then
+		dnl defaults
+		HAVE_FORTRAN=yes
+
+		AC_DEFINE([_HAVE_FORTRAN_],[1],[with fortran capability])
+	else
+		HAVE_FORTRAN=no
+	fi
+	AM_CONDITIONAL([FORTRAN], [test x$FORTRAN = xyes])
+	AC_MSG_RESULT($FORTRAN)
+
+	if test "x$FORTRAN" = "xyes"; then
+		dnl fortran library  option
+		AC_MSG_CHECKING(for fortran library)
+		AC_ARG_WITH([fortran-lib],
+		  AS_HELP_STRING([--with-fortran-lib = options],[fortran options, for ex: "/usr/lib/gfortran.a]),
+			[FORTRAN_LIB=$withval],[FORTRAN_LIB=""])
+
+		dnl check that --with-fortran-lib may have been provided
+		if test -n "$FORTRAN_LIB" ; then
+			FORTRANLIB="$FORTRAN_LIB"
+			AC_DEFINE([_HAVE_FORTRAN_],[1],[with FORTRAN in ISSM src])
+			AC_SUBST([FORTRANLIB])
+		fi
+		AC_MSG_RESULT(done)
+	fi
 	dnl }}}
 	dnl graphics{{{
@@ -981,4 +1127,21 @@
 	fi
 	AC_MSG_RESULT(done)
+	dnl }}}
+
+	dnl Capabilities
+	dnl with-kriging{{{
+	AC_ARG_WITH([kriging],
+		AS_HELP_STRING([--with-kriging = YES],[compile with kriging capabilities (default is yes)]),
+		[KRIGING=$withval],[KRIGING=yes]) 
+	AC_MSG_CHECKING(for kriging capability compilation)
+
+	if test "x$KRIGING" = "xyes"; then
+		HAVE_KRIGING=yes
+		AC_DEFINE([_HAVE_KRIGING_],[1],[with kriging capability])
+	else
+		HAVE_KRIGING=no
+	fi
+	AM_CONDITIONAL([KRIGING], [test x$HAVE_KRIGING = xyes])
+	AC_MSG_RESULT($HAVE_KRIGING)
 	dnl }}}
 	dnl with-steadystate{{{
@@ -1301,3 +1464,12 @@
 	AC_MSG_RESULT($USE_64BIT_INDICES)
 	dnl }}}
+	dnl circular-dependency{{{
+	AC_ARG_WITH([circular-dependency],
+	  AS_HELP_STRING([--with-circular-dependency = bool],[do we look for circular dependencies, default "yes", ex: --with-circular-dependency="no"]),
+	  [CIRCULAR_DEPENDENCIES=$withval],[CIRCULAR_DEPENDENCIES=yes]) 
+	AC_MSG_CHECKING(for circular dependencies)
+	AM_CONDITIONAL([CIRCULAR_DEPENDENCIES], [test x$CIRCULAR_DEPENDENCIES = xyes])
+	AC_MSG_RESULT($CIRCULAR_DEPENDENCIES) 
+
+	dnl }}}
 ])
